<?php
/**
 * @file
 * Helper functions for the Watcheezy Live Chat.
 */

/**
 * Watcheezy
 */
Watcheezy::addStylesheet('watcheezy', 'watcheezy.css'); 
Watcheezy::addScript('watcheezy', 'watcheezy.js'); 
 
function watcheezy_admin_settings_form($form_state) {
    global $language, $base_url;
    $we = Watcheezy::getInstance();
    $options_code_location = variable_get('watcheezy_code_location'); 
    
    if ($options_code_location == "m") {
        $display_manually = "style=''";
        $display_automatic = "style='display:none;'"; 
    } 

    if ($options_code_location == "a") {
        $display_manually = "style='display:none;'";
        $display_automatic = "style=''"; 
    }
     
    if ($we->isInstalled()) {
        if ($we->chatButtonInstalled()) {
          $form['live_chat'] = array(
            '#type' => 'item',
            '#markup' => t('<div class="messages status">Watcheezy is installed properly.</div>'),
          );
        }
        else {
          $form['live_chat'] = array(
            '#type' => 'item',
            '#markup' => t('<div class="messages warning">Please activate Wathceezy block in !url.</div>', array('!url' => l(t('Structure') . ' > ' . t('Blocks'), $base_url . '/admin/structure/block'))),
          );
        }
    }

    $form['general'] = array(
        '#type' => 'fieldset',
        '#collapsible' => FALSE,
        '#prefix' => '<h2>Watcheezy live chat</h2><p>This module allows you to easily incorporate chat services on your website without any dexterous knowledge of HTML and codes. Watcheezy is a remarkable solution which integrates live chat, visitor tracking and help desk services on your websites. Let your visitors contact you anytime through live chat and even if you are unable they can send offline messages and emails to let you always be in reach of your customers. Quickly add Watcheezy services on your website with few simple clicks and be live within 5 minutes or less.</p><div id="form-content" style="margin-top:25px;"><h3>eAssistance Pro Live Chat Code</h3><p>Log into your account, go to Home->Get Chat Button to customize the implementation, then copy and paste the HTML code below and click on "Save configuration".</p>',
        '#suffix' => '</div>',
        '#attributes' => array('style'=>'padding:1.1em 0 0'),
    ); 

    $form['general']['watcheezy_code_script'] = array( 
        '#type' => 'textarea',
        '#title' => t('Chat Code'),
        '#default_value' => variable_get('watcheezy_code_script', ''), 
        '#description' => t('For more options click <a href="http://www.watcheezy.com/fr/createfreemiumlicence.html" target="_blank">here</a>'),
        '#cols' => 100,
        '#rows' => 5,
        '#resizable' => FALSE,
        '#attributes' => array('style'=>'width:600px;resize: none;'),
    );

    $form['general']['watcheezy_code_location'] = array(
        '#type' => 'radios',
        '#default_value' => variable_get('watcheezy_code_location', 'a'), 
        '#options' => array('a' => t('Automatically insert in page'), 'm'=> t('Manually insert in page')),
    );

    $form['general']['codesnipt'] = array( 
        '#type' => 'textarea',
        '#default_value' => t('<?php if(function_exists("watcheezy_code")) { watcheezy_code(); } ?>'), 
        '#prefix' => '<div class="mannual" '.$display_manually.'><strong>Copy and paste below code anywhere in the page (after <body>)</strong>',
        '#cols' => 100,
        '#rows' => 1,
        '#resizable' => FALSE,
        '#attributes' => array('style'=>'width:600px;resize: none;'),
        '#suffix' => '</div>',
    );

    $form['general']['watcheezy_code_position'] = array(
        '#type' => 'radios',
        '#default_value' => variable_get('watcheezy_code_position', 'header'), 
        '#prefix' => '<div class="auto" '.$display_automatic.'>',
        '#options' => array('header' => t('Header'), 'footer'=> t('Footer'), 'leftbar'=> t('Leftbar'), 'rightbar'=> t('Rightbar')),
        '#suffix' => '</div>',
    );

    if ($we->isInstalled()) {
    if ($we->chatButtonInstalled()) {
      $form['general']['reset'] = array(
        '#type' => 'submit',
        '#value' => t('Reset settings'),
      );
    }
    }
  return system_settings_form($form);
}

/**
 * Watcheezy Form Validaion.
 */
function watcheezy_admin_settings_form_validate($form, &$data) {
    $we = Watcheezy::getInstance();
    
    if (isset($data['input']) && isset($data['input']['op']) && $data['input']['op'] === 'Reset settings') {
        $we->resetSettings();
    } else { 
        $response = $data['input']['watcheezy_code_script'];
        $response = htmlspecialchars_decode($response, ENT_QUOTES);  
        
        if (!strstr($response, "Error") === FALSE) {
            form_set_error('Error', t($response));
            
        } else {                                    
            variable_set('watcheezy_code_script', $response);
            variable_set('watcheezy_codesnipt', $data['input']['codesnipt']);   //for codesnipt 
            variable_set('watcheezy_code_location', $data['input']['watcheezy_code_location']);   //for manually
            variable_set('watcheezy_code_position', $data['input']['watcheezy_code_position']); //for automatically
        }
    }
}
