<?php
/**
 * @file
 * Class functions for the Watcheezy
 */

/**
 * Declatre Class.
 */
class Watcheezy {
  protected static $instance = NULL;
  protected $moduledir = NULL;

  /**
   * Function get Instance.
   */
  public static function getInstance() {
    if (is_null(self::$instance)) {
      self::$instance = new Watcheezy();
    }
    return self::$instance;
  }

  /**
   * Constructor.
   */
  protected function __construct() {
    $this->moduledir = drupal_get_path('module', 'watcheezy');
  }

  /**
   * Reset Settings.
   */
  public function resetSettings() {
    variable_del('watcheezy_firstname');
    variable_del('watcheezy_lastname');
    variable_del('watcheezy_mid');
  }

  /**
   * Validation.
   */
  public function validate($str) {
    if (trim($str) == "") {
      return FALSE;
    }
  }

  /**
   * Cheeck if module installed.
   */
  public function isInstalled() {

    $watcheezy_firstname = variable_get('wacheezy_firstname');
    $watcheezy_lastname = variable_get('watcheezy_lastname');
    $watcheezy_mid = variable_get('watcheezy_mid');

    if (is_null($watcheezy_firstname)) {
      return FALSE;
    }
    if (is_null($watcheezy_lastname)) {
      return FALSE;
    }
    if (is_null($watcheezy_mid)) {
      return FALSE;
    }
    return TRUE;
  }

  /**
   * Check is chat button installed.
   */
  public function chatButtonInstalled() {
    if ($this->isInstalled() == FALSE) {
      return FALSE;
    }
    $result = db_query('SELECT status FROM {block} WHERE module=:module', array(':module' => 'watcheezy'));
    $row = $result->fetchObject();
    if (!$row || $row->status != '1') {
      return FALSE;
    }
    return TRUE;
  }

  /**
   * Get Chat button code.
   */
  public function getChatCode() {
    $we = Watcheezy::getInstance();
    if ($we->chatButtonInstalled()) {
   
      $we_mid = variable_get('we_mid');
      $return = "<!-- WATCHEEZY -->\n<script language=\"text/javascript\" src=\"http://api.watcheezy.com/deliver/watcheezy.js?key=".$we_mid."&install=footer\"></script>\n<!-- END WATCHEEZY -->";
      return $return;
    }
      
  }

  /**
   * Connect to eassistancepro host and get live chat button code.
   */
  public function getRemote($url, $port = 80) {
    if (function_exists("curl_init")) {
      $curl_handle = curl_init();
      curl_setopt($curl_handle, CURLOPT_URL, $url);
      curl_setopt($curl_handle, CURLOPT_PORT, $port);
      curl_setopt($curl_handle, CURLOPT_HEADER, FALSE);
      curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER, TRUE);
      curl_setopt($curl_handle, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($curl_handle, CURLOPT_SSL_VERIFYHOST, 2);
      curl_setopt($curl_handle, CURLOPT_POST, FALSE);
      $data = curl_exec($curl_handle);
      curl_close($curl_handle);
    }
    else {
      $data = file_get_contents($url);
    }
    return $data;
  }
  
  public static function addStylesheet($modulename, $stylesheetname){
    drupal_add_css(drupal_get_path('module', $modulename) . '/'.$stylesheetname, array('group' => CSS_DEFAULT, 'type' => 'file'));
  }
  
  public static function addScript($modulename, $scriptname){
    drupal_add_js(drupal_get_path('module', $modulename) . '/'.$scriptname, array('type' => 'file'));
  }
}
